Skip to example

Conic gradient pointer

An example of creating a dynamic conic gradient with motion values and pointer position.

Vue

Source code

<script setup lang="ts">
import { motion, useMotionValue, useTransform, useDomRef } from 'motion-v'
import { onMounted, ref } from 'vue'

const elementRef = useDomRef()
const size = ref({ width: 0, height: 0, top: 0, left: 0 })
const gradientX = useMotionValue(0.5)
const gradientY = useMotionValue(0.5)
const background = useTransform(
  () =>
    `conic-gradient(from 0deg at calc(${
      gradientX.get() * 100
    }% - ${size.value.left}px) calc(${
      gradientY.get() * 100
    }% - ${size.value.top}px), #0cdcf7, #ff0088, #fff312, #0cdcf7)`
)

function measure() {
  if (!elementRef.value) return
  
  const rect = elementRef.value.getBoundingClientRect()
  size.value = {
    width: rect.width,
    height: rect.height,
    top: rect.top,
    left: rect.left
  }
}

function handlePointerMove(e) {
  gradientX.set(e.clientX / size.value.width)
  gradientY.set(e.clientY / size.value.height)
}

onMounted(() => {
  measure()
})
</script>

<template>
  <div
    class="container"
    @pointermove="handlePointerMove"
  >
    <motion.div
      ref="elementRef"
      class="gradient-box"
      :style="{ background }"
      @pointerenter="measure"
    />
  </div>
</template>

<style>
/**
 * ==============   Styles   ================
 */
.container {
  position: absolute;
  inset: 0;
  display: flex;
  align-items: center;
  justify-content: center;
}

.gradient-box {
  width: 400px;
  height: 400px;
  border-radius: 50px;
  cursor: none;
}
</style>

Skip to example

Conic gradient pointer

An example of creating a dynamic conic gradient with motion values and pointer position.

React

Source code

"use client"

import { motion, useMotionValue, useTransform } from "motion/react"
import { useEffect, useRef, useState } from "react"

export default function App() {
    const ref = useRef<HTMLDivElement>(null)
    const [{ width, height, top, left }, measure] = useElementDimensions(ref)
    const gradientX = useMotionValue(0.5)
    const gradientY = useMotionValue(0.5)
    const background = useTransform(
        () =>
            `conic-gradient(from 0deg at calc(${
                gradientX.get() * 100
            }% - ${left}px) calc(${
                gradientY.get() * 100
            }% - ${top}px), var(--hue-5), var(--hue-1), var(--yellow), var(--hue-5))`
    )

    return (
        <div
            style={{
                position: "absolute",
                inset: 0,
                display: "flex",
                alignItems: "center",
                justifyContent: "center",
            }}
            onPointerMove={(e) => {
                gradientX.set(e.clientX / width)
                gradientY.set(e.clientY / height)
            }}
        >
            <motion.div
                ref={ref}
                style={{
                    background,
                    width: 400,
                    height: 400,
                    borderRadius: 50,
                    cursor: "none",
                }}
                onPointerEnter={() => measure()}
            />
        </div>
    )
}

/**
 * ================  Utils  =========================
 */

function useElementDimensions(
    ref: React.RefObject<HTMLDivElement | null>
): [
    { width: number; height: number; top: number; left: number },
    VoidFunction
] {
    const [size, setSize] = useState({ width: 0, height: 0, top: 0, left: 0 })

    function measure() {
        if (!ref.current) return

        setSize(ref.current.getBoundingClientRect())
    }

    // Note: This won't accurately reflect viewport size changes
    useEffect(() => {
        measure()
    }, [])

    return [size, measure]
}